;
; MIDIO128
; MB_ADDR pointer return functions
;
; ==========================================================================
;
; Copyright (C) 1998-2003  Thorsten Klose (Thorsten.Klose@midibox.org)
;                          http://www.uCApps.de
; 
; ==========================================================================
; 
; This file is part of MIDIO128
;
; MIDIO128 is free software; you can redistribute it and/or modify
; it under the terms of the GNU General Public License as published by
; the Free Software Foundation; either version 2 of the License, or
; (at your option) any later version.
;
; MIDIO128 is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
; GNU General Public License for more details.
;
; You should have received a copy of the GNU General Public License
; along with MIDIO128; if not, write to the Free Software
; Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
;
; ==========================================================================

;; --------------------------------------------------------------------------
;;  This function returns a MB_ADDR[LH] pointer to the DIN entry,
;;  selected by MIDIO_CURRENT_DIN
;; --------------------------------------------------------------------------
MIDIO_ADDR_DINEntry
	SET_BSR	MIDIO_BASE
	;; low address of DIN event
	movf	MIDIO_CURRENT_DIN, W, BANKED
	mullw	6
	movf	PRODL, W
	addlw	(MIDIO_Presets_OffsetOut) & 0xff
	movwf	MB_ADDRL
	;; high address of DIN event
	movlw	((MIDIO_Presets_OffsetOut-MIDIO_Presets_FLASH_Lower) >> 8) & 0x03
	addwfc	PRODH, W
	movwf	MB_ADDRH
	return

;; --------------------------------------------------------------------------
;;  This function returns a MB_ADDR[LH] pointer to the DIN mode, 
;;  selected by MIDIO_CURRENT_DIN
;; --------------------------------------------------------------------------
MIDIO_ADDR_DINModeEntry
	SET_BSR	MIDIO_BASE
	;; low address of DIN value
	rrf	MIDIO_CURRENT_DIN, W, BANKED
	andlw	0x3f
	addlw	MIDIO_Presets_DIN_MODES & 0xff
	movwf	MB_ADDRL
	;; high address of DIN mode (EEPROM)
	movlw	0x04
	movwf	MB_ADDRH
	return

;; --------------------------------------------------------------------------
;;  This function returns MB_ADDR[LH] to the global settings page
;; --------------------------------------------------------------------------
MIDIO_ADDR_Global
	movlw	MIDIO_Presets_OffsetGlobal & 0xff
	movwf	MB_ADDRL
	movlw	0x04
	movwf	MB_ADDRH
	return

