;
; MIDIO Display functions
;
; ==========================================================================
;
; Copyright (C) 1998-2003  Thorsten Klose (Thorsten.Klose@midibox.org)
;                          http://www.uCApps.de
; 
; ==========================================================================
; 
; This file is part of MIDIO128
;
; MIDIO128 is free software; you can redistribute it and/or modify
; it under the terms of the GNU General Public License as published by
; the Free Software Foundation; either version 2 of the License, or
; (at your option) any later version.
;
; MIDIO128 is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
; GNU General Public License for more details.
;
; You should have received a copy of the GNU General Public License
; along with MIDIO128; if not, write to the Free Software
; Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
;
; ==========================================================================

;; --------------------------------------------------------------------------
;;  This handler is called from DISPLAY_Tick
;;  IN:  -
;;  OUT: -
;; --------------------------------------------------------------------------
MIDIO_DISPLAY_Handler
	;; don't continue of no display update has been requested
	IFCLR	MB_STAT, MB_STAT_DISPLAY_UPDATE_REQ, return
	;; clear flag
	bcf	MB_STAT, MB_STAT_DISPLAY_UPDATE_REQ

	;; first line: print last incoming event
	movlw	0x00
	call	MIOS_LCD_CursorSet

	SET_BSR	MIDIO_BASE
	movf	MIDIO_LAST_RECEIVED_EVNT0, W, BANKED
	bz	MIDIO_DISPLAY_Handler_NoInEvnt
MIDIO_DISPLAY_Handler_InEvnt
	movff	MIDIO_LAST_RECEIVED_EVNT0, MIDI_EVNT0
	movff	MIDIO_LAST_RECEIVED_EVNT1, MIDI_EVNT1
	movff	MIDIO_LAST_RECEIVED_EVNT2, MIDI_EVNT_VALUE
	call	MIDI_EVNT_Print
	rgoto	MIDIO_DISPLAY_Handler_InEvntCont
MIDIO_DISPLAY_Handler_NoInEvnt
MIDIO_DISPLAY_Handler_InEvntCont

	;; second line: print last outgoing event
	movlw	0x40
	call	MIOS_LCD_CursorSet
	movff	MIDIO_LAST_DIN0, WREG
	goto	MIDIO_LCD_PrintEvntStd_Btn

