;
; MIDIO128
; FSR pointer return functions
;
; ==========================================================================
;
; Copyright (C) 1998-2003  Thorsten Klose (Thorsten.Klose@midibox.org)
;                          http://www.uCApps.de
; 
; ==========================================================================
; 
; This file is part of MIDIO128
;
; MIDIO128 is free software; you can redistribute it and/or modify
; it under the terms of the GNU General Public License as published by
; the Free Software Foundation; either version 2 of the License, or
; (at your option) any later version.
;
; MIDIO128 is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
; GNU General Public License for more details.
;
; You should have received a copy of the GNU General Public License
; along with MIDIO128; if not, write to the Free Software
; Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
;
; ==========================================================================

;; --------------------------------------------------------------------------
;;  This function returns a FSR0 pointer to the button value depending on
;;  MIDIO_CURRENT_DIN
;; --------------------------------------------------------------------------
MIDIO_FSR_DINValue
	;; (status of 8 buttons stored in a SR register)
	SET_BSR	MIDIO_BASE
	lfsr	FSR0, MIDIO_DIN_VALUES_SR0
	rrf	MIDIO_CURRENT_DIN, W, BANKED
	rrf	WREG, F
	rrf	WREG, W
	andlw	0x07
	addwf	FSR0L, F
	return
